from typing import Any, Dict
from pyspark.sql import SparkSession

from Enum.InputTypeEnum import InputTypeEnum
from Enum.CloudProviderEnum import CloudProviderEnum
from Input.BucketAwsSource import BucketAwsInput


class Input:

    def __init__(self, input_type: str, session: SparkSession, params: Dict[str, Any], provider=None) -> None:
        self.input_type = input_type
        if not provider:
            provider = CloudProviderEnum.AWS.value
        if input_type == InputTypeEnum.BUCKET.value and provider == CloudProviderEnum.AWS.value:
            self.factory = BucketAwsInput(params["identifier"], session, params)

        self.data = None

    def get_data(self, replace: bool = False, replace_space_str: str = "\t") -> None:
        self.factory.get_data(replace, replace_space_str)
        self.data = self.factory.data

